
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import static java.nio.charset.StandardCharsets.US_ASCII;
import java.util.ArrayList;
import static java.util.Arrays.asList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.Random;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author cteam069
 */
public class Jump {

    static Pattern FIRST_NUM = Pattern.compile("\\b(\\d+)\\b");

    public static void main(String[] args) throws IOException {

      /*  String newInString
                = "7\n"
                + generateNs(10000) + "\n"
                + "0\n";

        ByteArrayInputStream newIn = new ByteArrayInputStream(newInString.getBytes(US_ASCII));

        System.setIn(newIn);
*/
       Map<Integer, List<Integer>> graph;

        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));

        
        while (true) {
         //   graph = readGraph(r);
          String s = r.readLine();
          if(s.equals("0")){
              return;
          }
          List<Integer> nums = findInts(r.readLine());
          List<Integer> reachable = new ArrayList<>();
          Queue<Integer> q = new LinkedList<>();
          q.add(0);
          while(!q.isEmpty()){
              
            int at = q.poll();
            reachable.add(at);
            
            for (Integer to : possibilities(nums, at)) {
                if (!reachable.contains(to)) {
                    q.add(to);
                }
            }
              
          }
          
            Collections.sort(reachable);
            System.out.println(reachable.get(reachable.size()-1));
        }

    }

    private static String generateNs(int n) {
        StringBuilder b = new StringBuilder();
        Random rand = new Random(164134134374437674L);
        for (int i = 0; i < n; i++) {
            if (n != 0) {
                b.append(' ');
            }
            b.append(rand.nextInt(n));
        }
        return b.toString();
    }

    private static boolean canReach(Map<Integer, List<Integer>> graph, int from) {
        Queue<Integer> q = new LinkedList<>();
        q.add(from);
        Set<Integer> visited = new HashSet<>();
        while (!q.isEmpty()) {
            int at = q.poll();
            if (at == 0) {
                return true;
            }
            visited.add(at);
          /*  System.out.println(graph);
            System.out.println(at);
            System.out.println(graph.get(at));*/
            for (Integer to : graph.get(at)) {
                if (!visited.contains(to)) {
                    q.add(to);
                }
            }

        }
        return false;
    }

    private static boolean adHoc(List<Integer> input, int from) {
        Queue<Integer> q = new LinkedList<>();
        q.add(from);
        Set<Integer> visited = new HashSet<>();
        while (!q.isEmpty()) {
            int at = q.poll();
            if (at == 0) {
                return true;
            }
            visited.add(at);
            for (Integer to : possibilities(input, at)) {
                if (!visited.contains(to)) {
                    q.add(to);
                }
            }

        }
        return false;
    }

    private static List<Integer> possibilities(List<Integer> in, int from) {
        List<Integer> moves = new ArrayList<>();
        for (int to = 0; to < in.size(); to++) {
            if (Math.abs(to - from) == in.get(from) + in.get(to)) {
                moves.add(to);
            }
        }
        return moves;
    }

    private static Map<Integer, List<Integer>> readGraph(BufferedReader r) throws IOException {
        String first = r.readLine();
        if (first.equals("0")) {
            return null;
        }
        List<Integer> nums = findInts(r.readLine());
     //   System.out.println(nums);
        Map<Integer, List<Integer>> graph = new HashMap<>();
        for(int i=0; i<nums.size(); i++){
            graph.put(i, new ArrayList<Integer>());
        }
        for (int from = 0; from < nums.size(); from++) {
            for (int to = from; to < nums.size(); to++) {
                if (Math.abs(to - from) == nums.get(from) + nums.get(to)) {
                    graph.get(from).add(to);
                    graph.get(to).add(from);
                }
            }
        }
        return graph;
    }
    
    /*
    private static List<Integer>lazy(Map<Integer, List<Integer>> graph,int key){
        List<Integer> l = graph.get(key);
        if(l == null){
            l=new ArrayList<>();
            graph.put(key, l);
            return l;
        }
        return l;
    }*/

    private static List<Integer> findInts(String in) {
        List<Integer> ints = new ArrayList<>();
        Matcher m = FIRST_NUM.matcher(in);
        while (m.find()) {
            ints.add(Integer.parseInt(m.group(1)));
        }

        return ints;
    }

}
