
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author cteam069
 */
public class Lunch {

    static Pattern FIRST_NUM = Pattern.compile("\\b(\\d+)\\b");

    public static void main(String[] args) throws IOException {

        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));

        while (true) {
            LunchPos lunch = readLunch(r);
            if (lunch == null) {
                return;
            }

            System.out.println(calcLunch(lunch));

        }

    }

    private static long calcLunch(LunchPos lunch) {
        long pos = 0;
        long total = lunch.soup.size()*lunch.meal.size()*lunch.dessert.size()*lunch.beverage.size();
        
        
        for (int soup = 0; soup < lunch.getSoup().size(); soup++) {
            long priceSoup = lunch.getSoup().get(soup);
            if (priceSoup >= lunch.max) {
                total = total - ()
                break;
            }
            for (int meal = 0; meal < lunch.getMeal().size(); meal++) {
                long priceMeal = lunch.getMeal().get(meal);
                if (priceSoup+priceMeal >= lunch.max) {
                    break;
                }
                for (int dessert = 0; dessert < lunch.getDessert().size(); dessert++) {
                    long priceDessert = lunch.getDessert().get(dessert);
                    if (priceSoup + priceMeal + priceDessert <= lunch.max) {
                        break;
                    }
                    for (int beverage = 0; beverage < lunch.getBeverage().size(); beverage++) {
                        long priceBeverage = lunch.getBeverage().get(beverage);
                        if (priceSoup + priceMeal + priceDessert + priceBeverage > lunch.max) {
                            break;
                        }
                        total--;
                    }
                }
            }
        }
        return pos;
    }

    private static LunchPos readLunch(BufferedReader r) throws IOException {
        String base = r.readLine();

        if (base.equals("0 0 0 0 0")) {
            return null;
        }
        Matcher m = FIRST_NUM.matcher(base);
        m.find();
        long max = Long.parseLong(m.group(1));

        String soup = r.readLine();
        String meal = r.readLine();
        String dessert = r.readLine();
        String beverage = r.readLine();
        String emptyline = r.readLine();

        return new LunchPos(max,
                findInts(soup),
                findInts(meal),
                findInts(dessert),
                findInts(beverage)
        );

    }

    private static List<Long> findInts(String in) {
        List<Long> longs = new ArrayList<>();
        Matcher m = FIRST_NUM.matcher(in);
        while (m.find()) {
            longs.add(Long.parseLong(m.group(1)));
        }

        return longs;
    }

    private static class LunchPos {

        private long max;
        private List<Long> soup;
        private List<Long> meal;
        private List<Long> dessert;
        private List<Long> beverage;

        public LunchPos(long max, List<Long> soup, List<Long> meal, List<Long> dessert, List<Long> beverage) {
            this.max = max;
            this.soup = soup;
            this.meal = meal;
            this.dessert = dessert;
            this.beverage = beverage;
            Collections.sort(this.soup, Comparator.reverseOrder());
            Collections.sort(this.meal, Comparator.reverseOrder());
            Collections.sort(this.dessert, Comparator.reverseOrder());
            Collections.sort(this.beverage,Comparator.reverseOrder());
        }

        public long getMax() {
            return max;
        }

        public List<Long> getSoup() {
            return soup;
        }

        public List<Long> getMeal() {
            return meal;
        }

        public List<Long> getDessert() {
            return dessert;
        }

        public List<Long> getBeverage() {
            return beverage;
        }

        @Override
        public String toString() {
            return "LunchPos{" + "max=" + max + ", soup=" + soup + ", meal=" + meal + ", dessert=" + dessert + ", beverage=" + beverage + '}';
        }

    }

}
